package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.UrgentCaseBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class UrgentCaseListModelImpl implements IUrgentCaseListModel {

    private OnGetUrgentCaseListListener listener;

    public UrgentCaseListModelImpl(OnGetUrgentCaseListListener urgentCaseListListener) {
        this.listener = urgentCaseListListener;
    }

    public interface OnGetUrgentCaseListListener {
        void onSuccess(UrgentCaseBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String isSupervise, int offset) {
        Observable<UrgentCaseBean> observable = RetrofitServiceManager.getUrgentCaseListResult(isSupervise, offset);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<UrgentCaseBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(UrgentCaseBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
